/* Bahamut IRCD Protocol Module
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: bahamut.h 427 2005-07-23 08:40:36Z trystan $
 *
 */

/*************************************************************************/

#define IRC_UMODE_a 0x00000001  /* umode +a - Services Admin */
#define IRC_UMODE_h 0x00000002  /* umode +h - Helper */
#define IRC_UMODE_i 0x00000004  /* umode +i - Invisible */
#define IRC_UMODE_o 0x00000008  /* umode +o - Oper */
#define IRC_UMODE_r 0x00000010  /* umode +r - registered nick */
#define IRC_UMODE_w 0x00000020  /* umode +w - Get wallops */
#define IRC_UMODE_A 0x00000040  /* umode +A - Server Admin */
#define IRC_UMODE_x 0x00000080  /* umode +x - Squelch with notice */
#define IRC_UMODE_X 0x00000100  /* umode +X - Squelch without notice */
#define IRC_UMODE_F 0x00000200  /* umode +F - no cptr->since message rate throttle */
#define IRC_UMODE_j 0x00000400  /* umode +j - client rejection notices */
#define IRC_UMODE_K 0x00000800  /* umode +K - U: lined server kill messages */
#define IRC_UMODE_O 0x00001000  /* umode +O - Local Oper */
#define IRC_UMODE_s 0x00002000  /* umode +s - Server notices */
#define IRC_UMODE_c 0x00004000  /* umode +c - Client connections/exits */
#define IRC_UMODE_k 0x00008000  /* umode +k - Server kill messages */
#define IRC_UMODE_f 0x00010000  /* umode +f - Server flood messages */
#define IRC_UMODE_y 0x00020000  /* umode +y - Stats/links */
#define IRC_UMODE_d 0x00040000  /* umode +d - Debug info */
#define IRC_UMODE_g 0x00080000  /* umode +g - Globops */
#define IRC_UMODE_b 0x00100000  /* umode +b - Chatops */
#define IRC_UMODE_n 0x00200000  /* umode +n - Routing Notices */
#define IRC_UMODE_m 0x00400000  /* umode +m - spambot notices */
#define IRC_UMODE_e 0x00800000  /* umode +e - oper notices for the above +D */
#define IRC_UMODE_D 0x01000000  /* umode +D - Hidden dccallow umode */
#define IRC_UMODE_I 0x02000000  /* umode +I - invisible oper (masked) */
#define IRC_UMODE_R 0x80000000  /* unmode +R - No non registered msgs */

/*************************************************************************/

#define IRCD_CMODE_i 0x00000001
#define IRCD_CMODE_m 0x00000002
#define IRCD_CMODE_n 0x00000004
#define IRCD_CMODE_p 0x00000008
#define IRCD_CMODE_s 0x00000010
#define IRCD_CMODE_t 0x00000020
#define IRCD_CMODE_k 0x00000040	/* These two used only by ChanServ */
#define IRCD_CMODE_l 0x00000080
#define IRCD_CMODE_R 0x00000100	/* Only identified users can join */
#define IRCD_CMODE_r 0x00000200	/* Set for all registered channels */
#define IRCD_CMODE_c 0x00000400	/* Colors can't be used */
#define IRCD_CMODE_M 0x00000800      /* Non-regged nicks can't send messages */
#define IRCD_CMODE_j 0x00001000      /* join throttle */
#define IRCD_CMODE_O 0x00008000	/* Only opers can join */

/*************************************************************************/

void bahamut_cmd_nick(char *nick, char *name, const char *modes);
void bahamut_cmd_mode(char *source, char *dest, char *buf);
void bahamut_cmd_bot_nick(char *nick, char *user, char *host, char *real, char *modes);
void bahamut_cmd_notice(char *source, char *dest, char *buf);
void bahamut_cmd_privmsg(char *source, char *dest, char *buf);
void bahamut_cmd_serv_notice(char *source, char *dest, char *msg);
void bahamut_cmd_serv_privmsg(char *source, char *dest, char *msg);
void bahamut_cmd_351(char *source);
void bahamut_cmd_quit(char *source, char *buf);
void bahamut_cmd_pong(char *servname, char *who);
void bahamut_cmd_join(char *user, char *channel, time_t chantime);
void bahamut_cmd_part(char *nick, char *chan, char *buf);
void bahamut_cmd_global(char *source, char *buf);
void bahamut_cmd_squit(char *servname, char *message);
void bahamut_cmd_connect(void);
void bahamut_cmd_eob(void);
void bahamut_cmd_ctcp(char *source, char *dest, char *buf);
void bahamut_cmd_version(char *server);
void bahamut_cmd_stats(char *sender, const char *letter, char *server);
void bahamut_cmd_motd(char *sender, char *server);
void bahamut_cmd_ping(char *server);
void bahamut_cmd_svinfo(void);
void bahamut_cmd_capab(void);
void bahamut_cmd_pass(char *pass);
void bahamut_cmd_server(char *servname, int hop, char *descript);
void bahamut_cmd_burst(void);

int denora_event_436(char *source, int ac, char **av);
int denora_event_away(char *source, int ac, char **av);
int denora_event_ping(char *source, int ac, char **av);
int denora_event_motd(char *source, int ac, char **av);
int denora_event_join(char *source, int ac, char **av);
int denora_event_kick(char *source, int ac, char **av);
int denora_event_kill(char *source, int ac, char **av);
int denora_event_mode(char *source, int ac, char **av);
int denora_event_quit(char *source, int ac, char **av);
int denora_event_squit(char *source, int ac, char **av);
int denora_event_topic(char *source, int ac, char **av);
int denora_event_whois(char *source, int ac, char **av);
int denora_event_part(char *source, int ac, char **av);
int denora_event_server(char *source, int ac, char **av);
int denora_event_nick(char *source, int ac, char **av);
int denora_event_privmsg(char *source, int ac, char **av);
int denora_event_capab(char *source, int ac, char **av);
int denora_event_sjoin(char *source, int ac, char **av);
int denora_event_error(char *source, int ac, char **av);
int denora_event_notice(char *source, int ac, char **av);
int denora_event_burst(char *source, int ac, char **av);
int denora_event_sqline(char *source, int ac, char **av);
int denora_event_pong(char *source, int ac, char **av);

int DenoraInit(int argc, char **argv);
void moduleAddIRCDMsgs(void);
void moduleAddIRCDCmds(void);
void DenoraFini(void);
