/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: ultimate3.h 427 2005-07-23 08:40:36Z trystan $
 *
 */

#define IRC_UMODE_a 0x00000001
#define IRC_UMODE_h 0x00000002
#define IRC_UMODE_i 0x00000004
#define IRC_UMODE_o 0x00000008
#define IRC_UMODE_r 0x00000010
#define IRC_UMODE_w 0x00000020
#define IRC_UMODE_A 0x00000040
#define IRC_UMODE_0 0x00000080
#define IRC_UMODE_Z 0x00000100   /* umode +Z - Services Root Admin */
#define IRC_UMODE_S 0x00000200   /* umode +S - Services Client */
#define IRC_UMODE_D 0x00000400   /* umode +D - has seen dcc warning message */
#define IRC_UMODE_d 0x00000800   /* umode +d - user is deaf to channel messages */
#define IRC_UMODE_W 0x00001000   /* umode +d - user is deaf to channel messages */
#define IRC_UMODE_p 0x04000000
#define IRC_UMODE_P 0x20000000   /* umode +P - Services Admin */
#define IRC_UMODE_x 0x40000000
#define IRC_UMODE_R 0x80000000


#define IRCD_CMODE_i 0x00000001
#define IRCD_CMODE_m 0x00000002
#define IRCD_CMODE_n 0x00000004
#define IRCD_CMODE_p 0x00000008
#define IRCD_CMODE_s 0x00000010
#define IRCD_CMODE_t 0x00000020
#define IRCD_CMODE_k 0x00000040		/* These two used only by ChanServ */
#define IRCD_CMODE_l 0x00000080
#define IRCD_CMODE_R 0x00000100		/* Only identified users can join */
#define IRCD_CMODE_r 0x00000200		/* Set for all registered channels */
#define IRCD_CMODE_c 0x00000400		/* Colors can't be used */
#define IRCD_CMODE_A 0x00000800
#define IRCD_CMODE_N 0x00001000
#define IRCD_CMODE_S 0x00002000
#define IRCD_CMODE_K 0x00004000
#define IRCD_CMODE_O 0x00008000		/* Only opers can join */
#define IRCD_CMODE_q 0x00010000      /* No Quit Reason */
#define IRCD_CMODE_M 0x00020000      /* Non-regged nicks can't send messages */

void ultimate3_cmd_nick(char *nick, char *name, const char *modes);
void ultimate3_cmd_mode(char *source, char *dest, char *buf);
void ultimate3_cmd_bot_nick(char *nick, char *user, char *host, char *real, char *modes);
void ultimate3_cmd_notice(char *source, char *dest, char *buf);
void ultimate3_cmd_privmsg(char *source, char *dest, char *buf);
void ultimate3_cmd_serv_notice(char *source, char *dest, char *msg);
void ultimate3_cmd_serv_privmsg(char *source, char *dest, char *msg);
void ultimate3_cmd_351(char *source);
void ultimate3_cmd_quit(char *source, char *buf);
void ultimate3_cmd_pong(char *servname, char *who);
void ultimate3_cmd_join(char *user, char *channel, time_t chantime);
void ultimate3_cmd_part(char *nick, char *chan, char *buf);
void ultimate3_cmd_global(char *source, char *buf);
void ultimate3_cmd_squit(char *servname, char *message);
void ultimate3_cmd_connect(void);
void ultimate3_cmd_eob(void);
void ultimate3_cmd_ctcp(char *source, char *dest, char *buf);
void ultimate3_cmd_version(char *server);
void ultimate3_cmd_stats(char *sender, const char *letter, char *server);
void ultimate3_cmd_motd(char *sender, char *servr);
void ultimate3_cmd_ping(char *server);
void ultimate3_cmd_pass(char *pass);
void ultimate3_cmd_server(char *servname, int hop, char *descript);
void ultimate3_cmd_capab(void);
void ultimate3_cmd_burst(void);
void ultimate3_cmd_svinfo(void);

int denora_event_436(char *source, int ac, char **av);
int denora_event_away(char *source, int ac, char **av);
int denora_event_ping(char *source, int ac, char **av);
int denora_event_motd(char *source, int ac, char **av);
int denora_event_join(char *source, int ac, char **av);
int denora_event_kick(char *source, int ac, char **av);
int denora_event_kill(char *source, int ac, char **av);
int denora_event_mode(char *source, int ac, char **av);
int denora_event_quit(char *source, int ac, char **av);
int denora_event_squit(char *source, int ac, char **av);
int denora_event_topic(char *source, int ac, char **av);
int denora_event_whois(char *source, int ac, char **av);
int denora_event_part(char *source, int ac, char **av);
int denora_event_server(char *source, int ac, char **av);
int denora_event_nick(char *source, int ac, char **av);
int denora_event_gnotice(char *source, int ac, char **av);
int denora_event_privmsg(char *source, int ac, char **av);
int denora_event_capab(char *source, int ac, char **av);
int denora_event_sjoin(char *source, int ac, char **av);
int denora_event_svinfo(char *source, int ac, char **av);
int denora_event_chghost(char *source, int ac, char **av);
int denora_event_sethost(char *source, int ac, char **av);
int denora_event_chgident(char *source, int ac, char **av);
int denora_event_setident(char *source, int ac, char **av);
int denora_event_chgname(char *source, int ac, char **av);
int denora_event_setname(char *source, int ac, char **av);
int denora_event_svsinfo(char *source, int ac, char **av);
int denora_event_snick(char *source, int ac, char **av);
int denora_event_vhost(char *source, int ac, char **av);
int denora_event_tkl(char *source, int ac, char **av);
int denora_event_eos(char *source, int ac, char **av);
int denora_event_eob(char *source, int ac, char **av);
int denora_event_pass(char *source, int ac, char **av);
int denora_event_netinfo(char *source, int ac, char **av);
int denora_event_error(char *source, int ac, char **av);
int denora_event_netctrl(char *source, int ac, char **av);
int denora_event_notice(char *source, int ac, char **av);
int denora_event_snotice(char *source, int ac, char **av);
int denora_event_sqline(char *source, int ac, char **av);
int denora_event_smo(char *source, int ac, char **av);
int denora_event_myid(char *source, int ac, char **av);
int denora_event_vctrl(char *source, int ac, char **av);
int denora_event_tctrl(char *source, int ac, char **av);
int denora_event_snetinfo(char *source, int ac, char **av);
int denora_event_globops(char *source, int ac, char **av);
int denora_event_burst(char *source, int ac, char **av);
int denora_event_sdesc(char *source, int ac, char **av);
int denora_event_svsmode(char *source, int ac, char **av);
int denora_event_sgline(char *source, int ac, char **av);
int denora_event_pong(char *source, int ac, char **av);
int denora_event_client(char *source, int ac, char **av);

int DenoraInit(int argc, char **argv);
void moduleAddIRCDMsgs(void);
void moduleAddIRCDCmds(void);
void DenoraFini(void);

